
import java.util.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;

import Cm.*;

class any_handler extends Handler
{
  public any_handler (String type)
      {
        super (type);
      }
  
  public void run (Message message, String sender)
      {
        while (message.get_item_type () == Message.ItemText)
          {
            System.out.println (message.get_text ());
          }
      }
}

class comment_handler extends Handler
{
  public comment_handler ()
      {
        super ("CmComment");
      }
  
  public void run (Message message, String sender)
      {
        while (message.get_item_type () == Message.ItemText)
          {
            System.out.println (message.get_text ());
          }
      }
}

class names_handler extends Handler
{
  public names_handler ()
      {
        super ("NSNames");
      }
  
  public void run (Message message, String sender)
      {
        while (message.get_item_type () == Message.ItemText)
          {
            System.out.println (message.get_text ());
          }
      }
}

class my_handler extends Handler
{
  public my_handler ()
      {
        super ("testcm");
      }
  
  public void run (Message message, String sender)
      {
        Message m = new Message ("testcm");
        
        m.put_char    ('a');
        m.put_char    ('b');
        m.put_char    ('c');
        m.put_short   ((short) 1);
        m.put_short   ((short) 11);
        m.put_short   ((short) 111);
        m.put_short   ((short) 1111);
        m.put_short   ((short) 11111);
        m.put_int     (1);
        m.put_int     (11);
        m.put_int     (111);
        m.put_int     (1111);
        m.put_int     (11111);
        m.put_int     (111111);
        m.put_int     (1111111);
        m.put_int     (11111111);
        m.put_int     (111111111);
        m.put_int     (1111111111);
        m.put_float   ((float) 1.111111);
        m.put_float   ((float) 1.111111e1);
        m.put_float   ((float) 1.111111e2);
        m.put_float   ((float) 1.111111e3);
        m.put_float   ((float) 1.111111e4);
        m.put_float   ((float) 1.111111e5);
        m.put_float   ((float) 1.111111e6);
        m.put_double  (1.111111);
        m.put_double  (1.111111e1);
        m.put_double  (1.111111e2);
        m.put_double  (1.111111e3);
        m.put_double  (1.111111e4);
        m.put_double  (1.111111e5);
        m.put_double  (1.111111e6);
        m.put_text    ("a");
        m.put_text    ("ab");
        m.put_text    ("abc");
        m.put_text    ("abcd");
        m.put_text    ("abcde");

        m.send (sender);
      }
}

class value_editor extends Panel
{
  public value_editor ()
      {
        setLayout (new BorderLayout ());

        m_types = new Choice ();
        m_types.addItem ("char");
        m_types.addItem ("short");
        m_types.addItem ("int");
        m_types.addItem ("long");
        m_types.addItem ("float");
        m_types.addItem ("double");
        m_types.addItem ("text");

        m_types.select ("text");

        add ("West", m_types);

        m_value = new TextField (20);
        add ("Center", m_value);
      }

  public void fill (Message message)
      {
        String type = m_types.getSelectedItem ();
        String value = m_value.getText ();

        if (value == null) return;
        value.trim ();
        if (value.length () == 0) return;

        if (type.equals ("char"))
          {
            message.put_char ((char) (new Byte (value).byteValue ()));
          }
        else if (type.equals ("short"))
          {
            message.put_short (new Short (value).shortValue ());
          }
        else if (type.equals ("int"))
          {
            message.put_int (new Integer (value).intValue ());
          }
/*
        else if (type.equals ("long"))
          {
            message.put_long (new Long (value).longValue ());
          }
*/
        else if (type.equals ("float"))
          {
            message.put_float (new Float (value).floatValue ());
          }
        else if (type.equals ("double"))
          {
            message.put_double (new Double (value).doubleValue ());
          }
        else if (type.equals ("text"))
          {
            message.put_text (value);
          }
      }

  private Choice    m_types;
  private TextField m_value;
}

public class tcm extends Applet
{
  private TextField m_to;
  private TextField m_type;
  private static Frame m_frame;
  private GridBagLayout m_grid;
  private GridBagConstraints m_constraints;
  private Panel m_value_panel;
  private Vector m_value_editors;

  public void init ()
      {
        m_frame.setLayout (new BorderLayout ());

        {
          MenuBar menu_bar = new MenuBar ();

          m_frame.setMenuBar (menu_bar);

          Menu file_menu = new Menu ("File");
          {
            MenuItem quit = new MenuItem ("Quit", 
                                          new MenuShortcut (KeyEvent.VK_Q));
            quit.addActionListener (new ActionListener ()
                {
                  public void actionPerformed (ActionEvent event)
                      {
                        System.exit (0);
                      }
                });
            
            file_menu.add (quit);
          }

          menu_bar.add (file_menu);
        }

        {
          Panel pa;
          
          pa = new Panel ();
          pa.setLayout (new BorderLayout ());

          {
            Panel p;
            
            p = new Panel ();
            p.add (new Label ("to  "));
            m_to = new TextField (16);
            p.add (m_to);
            
            pa.add ("North", p);
          }
          
          {
            Panel p;
            
            p = new Panel ();
            p.add (new Label ("type"));
            m_type = new TextField (16);
            p.add (m_type);
            
            pa.add ("Center", p);
          }

          m_frame.add ("North", pa);
        }

        {
          m_value_panel = new Panel ();

          m_grid = new GridBagLayout ();
          m_value_panel.setLayout (m_grid);

          GridBagConstraints c = new GridBagConstraints ();
        
          c.fill = GridBagConstraints.BOTH;
          c.gridwidth = GridBagConstraints.REMAINDER;

          m_constraints = c;

          {
            value_editor e = new value_editor ();
            
            m_grid.setConstraints (e,  m_constraints);
            m_value_panel.add (e);

            m_value_editors = new Vector ();
            m_value_editors.addElement (e);
          }

          m_frame.add ("Center", m_value_panel);
        }

        {
          Panel p;

          p = new Panel ();

          Button b = new Button ("more");
          b.addActionListener (new ActionListener ()
              {
                public void actionPerformed (ActionEvent event)
                    {
                      value_editor e = new value_editor ();
            
                      m_grid.setConstraints (e,  m_constraints);
                      m_value_panel.add (e);
                      m_frame.pack ();
                      m_value_editors.addElement (e);
                    }
              });
          p.add (b);

          b = new Button ("less");
          b.addActionListener (new ActionListener ()
              {
                public void actionPerformed (ActionEvent event)
                    {
                      int n = m_value_editors.size ();
                      if (n > 1)
                        {
                          value_editor e = (value_editor) 
                              m_value_editors.lastElement ();
                          m_value_panel.remove (e);
                          m_frame.pack ();
                          m_value_editors.removeElement (e);
                        }
                    }
              });
          p.add (b);
          
          m_frame.add ("East", p);
        }

        {
          Panel p;

          Button b = new Button ("send");
          b.addActionListener (new ActionListener ()
              {
                public void actionPerformed (ActionEvent event)
                    {
                      String to   = m_to.getText ();
                      String type = m_type.getText ();

                      Message m = new Message (type);

                      int i;
                      for (i = 0; i < m_value_editors.size (); i++)
                        {
                          value_editor e = (value_editor) 
                              m_value_editors.elementAt (i);
                          if (e != null) e.fill (m);
                        }

                      System.out.println ("Sending message " + type + 
                                          " to " + to);

                      if (!m.send (to))
                        {
                          System.out.println ("Error sending message");
                        }
                    }
              });
          p = new Panel ();
          p.add (b);
          
          m_frame.add ("South", p);
        }
        
        Server.open_multiple ("javacm");

        new my_handler ();
        new names_handler ();
        new any_handler ("CmComment");
      }

  public static void main (String argv[])
      {
        m_frame = new Frame ("javacm");
        tcm app = new tcm ();
        m_frame.add (app);
        app.init ();
        m_frame.pack ();
        m_frame.show ();
      }
}
